﻿using C1.WPF.ColorPicker;
using C1.WPF.Core;
using C1.WPF.Input;
using C1.WPF.PropertyGrid;
using C1.WPF.TabControl;
using System.Runtime.Serialization.Formatters;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace PropGridGradient
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            var avEdit = propGrid.AvailableEditors;
            propGrid.PreviewMouseDown += PropGrid_PreviewMouseDown;
        }


        private void PropGrid_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            if (e.OriginalSource is Rectangle rec)
            {
                if (rec.TemplatedParent is C1BrushPicker picker)
                {
                    var brEdit = picker.Template.FindName("BrushEditor", picker) as C1BrushEditor;
                    brEdit.Loaded += BrEdit_Loaded;
                }
                else if (rec.TemplatedParent is C1ToggleButton toggBtn)
                {
                    var par = toggBtn.TemplatedParent;
                    if (toggBtn.TemplatedParent is C1DropDownButton drpBtn)
                    {
                        if (drpBtn.Content is C1BrushEditor brEdit)
                        {
                            brEdit.Loaded += BrEdit_Loaded;
                        }
                    }
                }
            }
            else if (e.OriginalSource is C1CheckeredBorder chkBorder)
            {
                if (chkBorder.TemplatedParent is C1BrushPicker picker)
                {
                    var brEdit = picker.Template.FindName("BrushEditor", picker) as C1BrushEditor;
                    brEdit.Loaded += BrEdit_Loaded;
                }
            }
        }

        private void BrEdit_Loaded(object sender, RoutedEventArgs e)
        {
            if(sender is C1BrushEditor brushEdit)
            {
                var gradTab = brushEdit.Template.FindName("GradientBrushTab", brushEdit) as C1TabItem;
                if(gradTab != null)
                {
                    gradTab.Visibility = Visibility.Collapsed;
                }
            }
        }
    }
}